<?php
//
//	Module name      :	testodbccfg.php
//
//	Description      :	Test file for odbccfg module
//
//	Parameters       :	None
//	Notes - usage    :	None
//


//--- Include files --------------------------------------------------------------------------------



require_once("debug.php");
require_once("odbccfg.php");
require_once("odbc.php");



//--- Global constants -----------------------------------------------------------------------------



define("PAGE_TIMER_NAME", "TestPage");
define("TEST_TIMER_NAME", "TestFunc");



//--- Global variables -----------------------------------------------------------------------------



$Module_prefix = "OC";



//--- Functions code -------------------------------------------------------------------------------



function PrintFooter()
// Prints the test page footer.
{
	print "
		<!--- Start of PrintFooter ------------------------------------------------------>
		</body>
		</html>";
	$sec = DMtimerRead(PAGE_TIMER_NAME);
	print "
		<!--- End of PrintFooter -------------------------------------------------------->
		<!--- (Elapsed seconds for page construction: $sec) ------------------------->
		";
}



function PrintHeader($browser_title)
// Prints the test page header.
{
	DMtimerReset(PAGE_TIMER_NAME);
	$now = gmdate('D, d M Y H:i:s') . ' GMT';
	header('Expires: ' . $now);						// rfc2616 - Section 14.21
	header('Last-Modified: ' . $now);
	header('Cache-Control: no-store, no-cache, must-revalidate, pre-check=0, post-check=0, max-age=0'); // HTTP/1.1
	header('Pragma: no-cache'); // HTTP/1.0
	print "
		<!--- Start of PrintHeader ------------------------------------------------------>
		<html>
		<head>
			<title>$browser_title</title>
			<meta http-equiv='content-type' content='text/html; charset=iso-8859-1'>
		</head>
		<body>
		<!--- End of PrintHeader -------------------------------------------------------->
		";
}



function Test()
// Calls DPrint for each parameter passed; if ErrorMsg and Result are defined in the tested module,
// calls them and shows their values after the last parameter evaluation. Returns the value of the last
// parameter evaluation.
{
	global $Module_prefix;
	static $first_call = TRUE;

	$em_name = "${Module_prefix}ErrorMsg";
	$em = function_exists($em_name);
	$r_name = "${Module_prefix}Result";
	$r = function_exists($r_name);
	for ($i = 0; $i < func_num_args(); $i++)
		$result = DPrint(func_get_arg($i));
	if ($first_call)
	{
		$first_call = FALSE;
		$msec = 0;
	}
	else
		$msec = DMtimerRead(TEST_TIMER_NAME);
	DMTimerReset(TEST_TIMER_NAME);
	print "
		<table border=1 cellspacing=1 cellpadding=3 width=100%>
		<tr valign=top>
			<td width=1%>
				<center><font style='visibility:hidden'><b>DPrint</b></font></center>
			</td>
			<td><font size=-1>
				" . ($r ? "<b>${Module_prefix}Result:</b> '" . call_user_func($r_name) . "';" : "") . "
				" . ($em ? "<b>${Module_prefix}ErrorMsg:</b> '" . call_user_func($em_name) . "';" : "") . "
				<b>Elapsed secs from last call:</b> $msec</font>
			</td>
		</tr></table><br>
		";
	return $result;
}



//--- Main code ------------------------------------------------------------------------------------



	DSetDebugWindow(D_WIN_DEF_X, D_WIN_DEF_Y, D_WIN_DEF_WIDTH, D_WIN_DEF_HEIGHT, FALSE);
	PrintHeader("Test file for " . constant("${Module_prefix}_MODULE_NAME"));
	Test("Initial internal status");

	// Test code for odbccfg.php starts here.

	$My_db = array("Dsn" => "statisticheasync", "User" => "apache", "Pwd" => "linuzzo");
	DPrint(ODBCInit($My_db), ODBCExtErrorMsg());
	
	DPrint("<font size=+1><font color=blue><b>OCInit</b></font></font>");
	$My_cfg = array(
			"CfgTableName"	=> "MyCfgTableName",
			"SecFieldName"	=> "MySecFieldName",
			"VarFieldName"	=> "MyVarFieldName",
			"ValFieldName"	=> "MyValFieldName"
			);
	Test(OCInit($My_cfg, $My_db));
	DPrint($My_cfg);
	$My_cfg = array();
	Test(OCInit($My_cfg, $My_db));
	DPrint($My_cfg);
	
	DPrint("<font size=+1><font color=blue><b>OCDone</b></font></font>");
	Test(OCDone($My_cfg));
	DPrint($My_cfg);

	DPrint("<font size=+1><font color=blue><b>OCReadVar</b></font></font>");
	Test(OCInit($My_cfg, $My_db));
	Test(OCReadVar($My_cfg, "TestSec", "VarNonEsitente", "ValDiDefault"));
	Test(OCReadVar($My_cfg, "TestSec", "TestVal", "ValDiDefault"));	// "TestSec":"TestVal" (= 5) deve esistere
	Test(OCReadVar($My_cfg, "", "TestVal", "ValDiDefault"));		// "":"TestVal" (= 6) deve esistere

	DPrint("<font size=+1><font color=blue><b>OCVarExists</b></font></font>");
	Test(OCVarExists($My_cfg, "TestSec", "VarNonEsitente"));
	Test(OCVarExists($My_cfg, "TestSec", "TestVal"));
	Test(OCVarExists($My_cfg, "", "TestVal"));

	DPrint("<font size=+1><font color=blue><b>OCWriteVar</b></font></font>");
	Test(OCReadVar($My_cfg, "TestSec", "VarNonEsitente2", "ValDiDefault"));
	Test(OCWriteVar($My_cfg, "TestSec", "VarNonEsitente2", 11));
	Test(OCReadVar($My_cfg, "TestSec", "VarNonEsitente2", "ValDiDefault"));
	Test(OCReadVar($My_cfg, "", "TestVal", "ValDiDefault"));
	Test(OCWriteVar($My_cfg, "", "TestVal", 12));
	Test(OCReadVar($My_cfg, "", "TestVal", "ValDiDefault"));
	Test(OCWriteVar($My_cfg, "", "TestVal", 6));

	DPrint("<font size=+1><font color=blue><b>OCDeleteVar</b></font></font>");
	Test(OCReadVar($My_cfg, "TestSec", "VarNonEsitente2", "ValDiDefault"));
	Test(OCDeleteVar($My_cfg, "TestSec", "VarNonEsitente2"), ODBCAffectedRows($My_db), ODBCErrorMsg());
	Test(OCReadVar($My_cfg, "TestSec", "VarNonEsitente2", "ValDiDefault"));
	Test(OCDeleteVar($My_cfg, "TestSec", "VarNonEsitente2"), ODBCAffectedRows($My_db), ODBCErrorMsg());

	DPrint("<font size=+1><font color=blue><b>OCSectionExists</b></font></font>");
	Test(OCSectionExists($My_cfg, "SecNonEsistente"));
	Test(OCSectionExists($My_cfg, "TestSec"));
	Test(OCSectionExists($My_cfg, ""));

	DPrint("<font size=+1><font color=blue><b>OCReadSection</b></font></font>");
	Test(OCReadSection($My_cfg, "SecNonEsistente"));
	Test(OCReadSection($My_cfg, "SecNonEsistente", OC_STD));
	Test(OCReadSection($My_cfg, "TestSec"));
	Test(OCReadSection($My_cfg, "TestSec", OC_STD));
	Test(OCReadSection($My_cfg, ""));
	Test(OCReadSection($My_cfg, "", OC_STD));

	DPrint("<font size=+1><font color=blue><b>OCReadSections</b></font></font>");
	Test(OCReadSections($My_cfg));
	Test(OCReadSections($My_cfg, OC_STD));

	DPrint("<font size=+1><font color=blue><b>OCDeleteSection</b></font></font>");
	Test(OCReadSection($My_cfg, "TestSec"));
	Test(OCDeleteSection($My_cfg, "TestSec"));
	Test(OCReadSection($My_cfg, "TestSec"));

	// Test code for odbccfg.php ends here.

	Test("Final internal status");
	PrintFooter();	
?>
